<?php

	class sidebar_discount {
		
		public $cfg = Array(
			
			//Данные для подключения к БД
			'db' =>	array (
		
				'host'	=> 'localhost',
				'name'	=> 'lk',
				'user'	=> 'root',
				'pass'	=> '',
				'char'	=> 'utf8' //utf8 или cp1251
		
			),
			
			//Данные от таблицы с предметами
			'table'	=>	array(
				
				//Имя таблицы
				'name'	=>	'shop_blocks',
				
				//Колонки
				'columns'	=>	array(
					//Колонка с ID   (ID предмета в магазине, а не в майнкрафте)
					'id'		=>	'id',
					//Колонка(-и) с ID предмета. Если предмет хранится в базе как, например, 5:1, то пишем вместо block_n двоеточие
					'mc_ID'		=>	array( 'block_id', 'block_n' ),
					//Колонка с названием
					'name'		=>	'name',
					//Колонка со скидкой
					'discount'	=>	'discount',
					//Колонка с магазином/сервером
					'shop'		=>	'server',
					//Колонка с ценой
					'price'		=>	'price'
				),
				
				//Условие. Пр умолчанию: если скидка больше 0
				'if'	=>	'discount > 0'
			),
			
			//Пути
			'path'	=>	array(
				
				'img'	=>	array('shop/blocks/', /*SERVER*/ '/', /*ID 1*/ '_', /*ID 2*/ '.png')
				
			),
			
			//Валюта
			'cur'	=>	'руб'
			
			//Ссылка на страницу с предметов редактируется на 94 строке
		);
		
		public $db;
		public $item;
		
		function __construct()
		{
			$this->db = new PDO('mysql:host='.$this->cfg['db']['host'].';dbname='.$this->cfg['db']['name'], $this->cfg['db']['user'], $this->cfg['db']['pass']);
			$this->db->query("SET NAMES '".$this->cfg['db']['char']."'");
		}
		
		function getRandomItemByDiscount() {
			return $this->db->query("SELECT * FROM `{$this->cfg['table']['name']}` WHERE {$this->cfg['table']['if']} ORDER BY RAND() LIMIT 1")->fetch(PDO::FETCH_ASSOC);
		}
		
		function getValue( $name ) {
			return $this->item[$this->cfg['table']['columns'][$name]];
		}
		
		function getValueID($type) {
			$ids = $this->cfg['table']['columns']['mc_ID'];
			
			if ( STRLEN($ids[1]) != 1 ) {
				return $this->item[$ids[$type]];
			} else {
				$_ids = explode($ids[1], $this->item[$ids[0]]);
				return $_ids[$type];
			}
		}
		
		function pathImg() {
			return $this->cfg['path']['img'][0] . $this->getValue('shop') . $this->cfg['path']['img'][1] . $this->getValueID(0) . ($this->getValueID(1) ? $this->cfg['path']['img'][2] . $this->getValueID(1) : '') . $this->cfg['path']['img'][3];
		}
	}
	
	$sd = new sidebar_discount();
	$sd->item = $sd->getRandomItemByDiscount();
?>

<div class="sidebar_discount" align="center" onclick="window.location.href =   'index.php?do=shop&shop=<?php echo $sd->getValue('shop')?>&id=<?php echo $sd->getValue('id')?>'   ;">
	<div class="sidebar_discount_head"><?php echo $sd->getValue('name')?></div>
	<div class="sidebar_discount_block">
		<img src="<?php echo $sd->pathImg()?>" width="70" height="70"/>
		<div class="sidebar_discount_block-desc">
			<div class="sidebar_discount_block-desc-dis">Скидка <b><?php echo $sd->getValue('discount')?>%</b>!</div>
			<div class="sidebar_discount_block-desc-price">Цена <b><?php echo ($sd->getValue('price') - ($sd->getValue('price') / 100 * $sd->getValue('discount')))?></b> <?php echo $sd->cfg['cur']?></div>
			<div class="sidebar_discount_block-desc-oldprice"><?php echo $sd->getValue('price')?> <?php echo $sd->cfg['cur']?></div>
		</div>
	</div>
</div>

<style>
	.sidebar_discount {
		
		width: 170px;
		height: 200px;
		background: #FBFBFB;
		border: 1px solid #EFEFEF;
		border-radius: 10px 10px 5px 5px;
		font-family: calibri;
		font-size: 14px;
		cursor: pointer;
		margin: 0 auto;
		
		-webkit-box-shadow: 1px 1px 1px 0px rgba(50, 50, 50, 0.75);
		-moz-box-shadow:    1px 1px 1px 0px rgba(50, 50, 50, 0.75);
		box-shadow:         1px 1px 1px 0px rgba(50, 50, 50, 0.75);
		
	}
	
	.sidebar_discount:hover {
		
		-webkit-box-shadow: 1px 1px 3px 0px rgba(50, 50, 50, 0.75);
		-moz-box-shadow:    1px 1px 3px 0px rgba(50, 50, 50, 0.75);
		box-shadow:         1px 1px 3px 0px rgba(50, 50, 50, 0.75);
		
	}
	
	.sidebar_discount_head {
		border-radius: 10px 10px 5px 5px;
		background: #FFFFFF;
		padding: 5px;
		font-size: 15px;
	}
	
	.sidebar_discount_block {
		padding: 5px;
	}
	
	.sidebar_discount_block-desc {
		margin-top: 10px;
	}
	
	.sidebar_discount_block-desc-dis {
		font-size: 17px;
		color: #FF5757;
	}
	
	.sidebar_discount_block-desc-price {
		margin-top: 5px;
		font-size: 20px;
	}
	
	.sidebar_discount_block-desc-oldprice {
		margin-top: 5px;
		font-size: 15px;
		color: #787878;
		text-decoration: line-through;
	}
</style>